//  prelosder
body {

    &.page {
        overflow: hidden;
    }

    &.visible {
        overflow: visible;
    }

    .preloader {
        transition: transform 3s ease;
        display: flex;
        align-items: center;
        justify-content: center;
        position: fixed;
        z-index: 100;
        top: 0;
        left: 0;
        right: 0;
        bottom: 0;
        width: 100vw;
        height: 100vh;
        background-color: $main-color-bg-preloader;
        overflow: hidden;
    
        &__wrapp {
            position: relative;
    
            &::after {
                content: '';
                background-color: rgba(18, 18, 18, 0.5);
                position: absolute;
                z-index: 1;
                left: 0;
                right: 0;
                top: 0;
                bottom: 0;
                transform: translateY(0);
                // transition: transform 2.8s linear;
            }
        }
    }

    .preloader-start {
        // transform: translateY(0);
        animation: preloader_animation 1.2s $main-transition-timing 2.8s forwards;
        // transition: transform 1.2s $main-transition-timing;
        // animation-delay: 2.8s;

        .preloader__wrapp {
    
            &::after {
                // transform: translateY(-100%);
                animation: preloader_animation 2.8s linear forwards;
            }
        }
    }

    // .preloader-start {

    //     .preloader__wrapp {
    
    //         &::after {
    //             // transform: translateY(-100%);
    //             animation: preloader_animation 2.8s linear;
    //         }
    //     }
    // }

    // preloader menu mobile
    .preloader-menu-mob {

        @include media-laptop {
            width: 100vw;
            height: 100vh;
            position: fixed;
            background-color: $color-main;
            z-index: 10;
            will-change: transform;
            transition: transform 1s cubic-bezier(.74,-0.02,.24,1.01);
            transform: translate(0, -100%);
        }
    }

    .preloader-menu-mob-start {

        @include media-laptop {
            transform: translate(0, 100%);
        }
    }
}

// title basic
.title_basic {
    
    @include main-animation;
}

// menu
.animation-wrapp-wave {
    position: relative;
    display: inline-block;
    line-height: 1;

    .wave-item {
    display: flex;
    position: absolute;
    top: 0;
    left: 0;

        span {
            will-change: transform;
            transform-style: preserve-3d;
            transition: .5s ease;
            transition-delay: calc(.05s * var(--index));
            transform-origin: bottom;
            display: inline-block;
        }
    }

    .wave-item-clone {
        display: flex;
        font-style: italic;

        span {
            will-change: transform;
            transform-style: preserve-3d;
            transition: .5s ease;
            transition-delay: calc(.05s * var(--index));
            transform-origin: top;
            display: inline-block;
            transform: translateY(100%) rotateX(-90deg);
        }
    } 

    span {
        display: inline-block;
        padding: 0;
        margin: 0;
    }
}

.animation-wrapp-wave:hover .wave-item span {
    transform: translateY(-100%) rotateX(-90deg);
}

.animation-wrapp-wave:hover .wave-item-clone span {
    transform: translate(0) rotateX(0);
}

// button
.button-default {

    .button-default__link::before {
        content: '';
        position: absolute;
        z-index: 1;
        left: 0;
        bottom: -5px;
        background: $color-hover;
        height: 1px;
        width: 100%;
        transform-origin: right;
        transform: scaleX(0);
        transition: transform .8s cubic-bezier(.16, 1, .3, 1);
    }
    
    &:hover .button-default__link::before {
        transform: scaleX(1);
        transform-origin: left;
    }

    &::before, &::after {
        content: '';
        display: block;
        width: 20px;
        height: 20px;
        background: no-repeat center center /cover  url('./images/arrow.png');
        position: absolute;
        transform: translateY(-50%);
    }

    &::before {
        right: 32px;
        bottom: -40px;
    }

    &::after {
        right: 0;
        top: 50%;
    }

    &:hover:after {
        animation: arrow_after 0.5s ease-out;
    }

    &:hover:before {
        animation: arrow_before 0.5s ease-out;
    }
}

// header 
header {
    opacity: 0;
    transform: translateY(-30px);
    animation: opacity 1s linear forwards,
    header 0.5s linear forwards;
    animation-delay: 4.5s;
}

// section banner
.section-banner {
    animation: opacity 1.5s ease;
    position: relative;

    .headline-items  {
        @include main-animation;
        opacity: 0;
        animation: main_animation 2s cubic-bezier(.22,.17,.26,.83) forwards;
        animation-delay: 3.5s;
    }

    .subtitle {
        opacity: 0;
        animation: main_animation_title 2s ease forwards;
        animation-delay: 4s;
    }

    &__bg {

        .banner-circle-light {
            position: absolute;
            top: 27%;
            left: -3%;
            width: 150px;
            height: 150px;

            @include media-laptop {
                top: 40%;
            }

            @include media-mobile {
                top: 27%;
            }

            .banner-circles {
                position: absolute;
                top: 175%;
                left: -60%;

                @include media-laptop {
                    left: 132%;
                }
            }

            .circle-item-small-wrapp, .circle-item-big-wrapp {
                width: 20px;
                height: 20px;
                display: inline-block;
                animation:  circle 10s linear infinite;
            }

            .circle-item-big-wrapp {
                animation:  circle 15s linear infinite;
            }

            .banner-circle-item {
                display: block;
                border-radius: 50%;
                z-index: 2;
                background: linear-gradient(241.52deg, rgba(243, 243, 243, 0.03) 17.39%, rgba(255, 255, 255, 0.04) 38.12%, rgba(255, 255, 255, 0.04) 77.42%);
                mix-blend-mode: normal;
                opacity: 0.75;
                box-shadow: inset -5px -5px 15px rgba(0, 255, 255, 0.15);
                backdrop-filter: blur(50px); 
            }

            .circle-item-small {
                width: 60px;
                height: 60px;
                animation: inner-circle 10s linear infinite;
                transform-origin: 2% 14px;

                @include media-mobile {
                    width: 40px;
                    height: 40px;
                }
            }

            .circle-item-big {
                width: 100px;
                height: 100px;
                animation: inner-circle 15s linear infinite;
                transform-origin: 2% 14px;

                @include media-mobile {
                    width: 80px;
                    height: 80px;
                }
            }

            .banner-light-wrapp {
                width: 20px;
                height: 20px;
                animation: circle 5s linear infinite;
                display: inline-block;
                position: absolute;
                top: 160%;

                @include media-laptop {
                    display: none;
                }
            
                .banner-light {
                    width: 15rem;
                    height: 15rem;
                    display: block;
                    background: radial-gradient(35.94% 36.06% at 56.79% 55.92%, rgba(0, 255, 255, 0.35) 47.34%, rgba(0, 203, 232, 0.256392) 67.65%, rgba(0, 158, 212, 0.175) 100%);
                    filter: blur(53px);
                    animation: inner-circle 5s linear infinite;
                    transform-origin: 5% 5%;
                }
            }
        }
    }

    .halo {
        position: absolute;
        right: 0;
        width: 100%;
        height: 100%;
        top: 0;
        left: 0;
        background: linear-gradient(180deg, #00FFFF 0%, #2366B5 100%);
        mix-blend-mode: color-dodge;
        opacity: 0.21;
        filter: blur(137.731px);
        z-index: 1;

        @include media-laptop {
            display: none;
        }

        img {
            width: 100%;
            height: 100%;
        }
    }

    .button-default {
        opacity: 0;
        transform: translateY(30px);
        animation: opacity 1s linear forwards,
        button_banner 0.5s linear forwards;
        animation-delay: 4.5s;
    }
}

// section about
.section-about {
    position: relative;

    .circles-about {
        position: absolute;
        top: 0;
        bottom: 0;
        right: 0;
        left: 18%;

        @include media-laptop {
            top: -60%;
            bottom: 0;
            right: 35%;
            left: auto;
        }

        @include media-mobile {
            right: 18%;
        }

        .circle-about-big-wrapp {
            width: 20px;
            height: 20px;
            left: 8%;
            position: absolute;
            top: -10%;
            animation: circle 10s linear infinite;
            z-index: 1;
            background-blend-mode: color-dodge;
            mix-blend-mode: color-dodge;

            @include media-laptop {
                width: 30px;
                top: -70%;
            }

            @include media-tablet {
                top: -40%;
            }

            @include media-mobile {
                top: -16%;
            }

            .circle-about-big {
                width: 650px;
                height: 650px;
                transform: translate(55%, -24%);
                background: linear-gradient(209.12deg, #00FFFF 10.92%, #2366B5 87.03%);
                background-blend-mode: color-dodge;
                mix-blend-mode: color-dodge;
                border-radius: 50%;
                z-index: 1;
                opacity: 20%;
                transition: translate, opacity 0.5s;
                animation: inner-circle 10s linear infinite;
                transform-origin: 3% 3%;

                @include media-laptop {
                    width: 75vw;
                    height: 75vw;
                }

                @include media-mobile {
                    width: 325px;
                    height: 325px;
                }

                img {
                    height: 100%;
                }
            }
        }

        .circle-about-light-wrapp {
            width: 20px;
            height: 20px;
            position: absolute;
            left: -8%;
            top: 30%;
            animation: circle 5s linear infinite;

            @include media-laptop {
                left: auto;
                right: 80px;
                top: -25%;
            }

            @include media-tablet {
                top: -10%;
            }

            @include media-mobile {
                right: 50px;
                top: -2%;
            }

            .circle-about-light {
                width: 200px;
                height: 200px;
                background: radial-gradient(35.94% 36.06% at 56.79% 55.92%, #00FFFF 47.34%, rgba(0, 203, 232, 0.732548) 67.65%, rgba(0, 158, 212, 0.5) 100%);
                top: 45%;
                border-radius: 50%;
                opacity: 80%;
                filter: blur(35px);
                transform: translate(7%, -81%);
                animation: inner-circle 5s linear infinite;
                transform-origin: 3% 3%;

                @include media-mobile {
                    width: 150px;
                    height: 150px;
                }
            }
        }
    }

    .title_about, p, .button-default {
        opacity: 0;
    }

    &.section-about-animation {

        .title_about {
            @include main-animation;
            animation: main_animation_title 1.5s ease forwards;
        }
    
        p {
            @include main-animation-small;
            animation: main_animation 1.5s ease forwards;
            animation-delay: 0.7s;
        }
    
        .button-default {
            opacity: 0;
            transform: translateY(30px);
            animation: opacity 1s linear forwards,
            button_banner 0.5s linear forwards;
            animation-delay: 1.4s;
        }
    }
}

// section slider
.section-slider {

    .slider-swiper {
        overflow: visible;
    }

    .slider-item-name-hover {
        @include font-slider-hover;
        @include font-slider;
        @include transition-main;

        @include media-laptop {
            opacity: 0;
        }

        position: absolute;
        top: 0;
        opacity: 0;

        &::before {
            content: '';
            @include mark-slider;
        }

        &:hover {
            @media (min-width: $mediaWidthTablet) {
                opacity: 100%;
            }
        }
    }

    li.is-active {

        .slider-item-name-hover {
            @include media-laptop {
                opacity: 1;
                -webkit-text-stroke: 1px transparent;
                text-stroke: 1px transparent;
            }
        }
    }

}

// section cards services 
.section-cards {

    .card-services {
        padding: 2px;
        overflow: hidden;

        &__inner {
            position: relative;
            height: 100%;
            
            &::after, &::before {
                content: '';
                position: absolute;
            }

            &::after {
                z-index: -2;
                top: -1px;
                bottom: -1px;
                left: -1px;
                right: -1px;
                background: linear-gradient(180deg, #B9B9B9 0%, rgba(102, 102, 102, 0) 100%);
            }
            
            &::before {
                z-index: -1;
                top: calc(-2px - 25%);
                bottom: calc(-2px - 25%);
                left: calc(-2px - 25%);
                right: calc(-2px - 25%);
                background: linear-gradient(141.8deg, #00FFFF 14.44%, #01C4E5 86.47%);
                transform: translate(-100%, -100%);
                border-radius: 50%;
                transition: transform 0.7s linear;
            }

            &:hover:before, &:hover:focus, &:active:before {
               transform: translate(0, 0);
            }
        }

        .color-card {
            .card-services__inner {
                border-color: transparent;

                &:before  {
                    transform: translate(0, 0);
                 }
            }
        }
    }

    .card-services:hover {

        .animation-wrapp-wave .wave-item span {
            transform: translateY(-100%) rotateX(-90deg);
        }
        
        .animation-wrapp-wave .wave-item-clone span {
            transform: translate(0) rotateX(0);
        }
        &::after {
            z-index: -1;
        } 
    }

    .card-services {
        opacity: 0;
    }

    .card-services-0:hover, .card-services-1:hover, .card-services-2:hover, .card-services-3:hover {

        .card-icon {

            &::after {
                opacity: 1;
            }
        }
    }

    &.section-cards-animation {
    
        .title_basic {
            @include main-animation;
            animation: main_animation_title 1.5s ease forwards;
        }
    
        .card-services {
            @include card_basic_style;
            animation: card_basic 1.5s $main-transition-timing forwards;
        }
    
        .card-services-0 {
            animation-delay: 1s;
        }
    
        .card-services-1 {
            animation-delay: 1.3s;
        }
    
        .card-services-2 {
            animation-delay: 1.6s;
        }
    
        .card-services-3 {
            animation-delay: 1.9s;
        }
    }
}

// section offers
.section-offers {

    .section-offers__cards {
        position: relative;

        // hide 

        // &::after {
        //     content: '';
        //     background: url('./images//section-offers-bg.svg') center center /cover;
        //     width: 100%;
        //     height: 670px;
        //     position: absolute;
        //     z-index: -1;
        //     top: 0;
        //     opacity: 0;

        //     @include media-mobile {
        //         display: none;
        //     }
        // }
    }

    .section-offers__card {
        opacity: 0;
    }

    &.section-offers-animation {

        .title_basic {
            @include main-animation;
            animation: main_animation_title 1.5s ease forwards;
        }

        .section-offers__cards {
    
            &::after {
                animation: opacity 2.5s ease forwards;
                animation-delay: 1.2s;
            }
        }
    
        .section-offers__card {
            @include card_basic_style;
            animation: card_basic 1.2s $main-transition-timing forwards;
            animation-delay: 0.5s;
    
            &:nth-child(2) {
                animation-delay: 0.8s;
            }
    
            &:nth-child(3) {
                animation-delay: 1.1s;
            }
        }
    }
}

// section team 
:root {
    --cube-width: 0;
    --cube-width-minus: 0;
}

.section-team {
    position: relative;

    .item-photo {
        opacity: 0;
        transform: translateY(120%);
    }

    .cube-item {
        border: 1px solid $color-border-second;
    }

    .cube-item.front-cube {
        border: transparent;
    }

    .container {
        height: 100%;
        cursor: pointer;
    }

    .front-cube {
        transform: translateZ(calc(var(--cube-width) / 2));
    }

    .back-cube {
        transform: translateZ(-calc(var(--cube-width) / 2)) rotateY(-180deg);
        display: none;
    }

    .top-cube {
        transform: translateY(calc(var(--cube-width-minus) / 2)) rotateX(90deg);
    }

    .bottom-cube {
        transform: translateY(calc(var(--cube-width) / 2)) rotateX(90deg);
    }

    .left-cube {
        transform: translateX(calc((var(--cube-width-minus)) / 2)) rotateY(-90deg) translateZ(-2px);
    }

    .right-cube {
        transform: translateX(calc(var(--cube-width) / 2)) rotateY(90deg) translateZ(-2px);
    }

    &.section-team-animation {

        .title_basic {
            @include main-animation;
            animation: main_animation_title 3s ease forwards;
        }

        .item-photo {
            animation: translate-item-team 2s $main-transition-timing forwards;
        }
    
        @for $i from 0 through 8 {
        
            .item-photo-#{$i} {
                animation-delay: #{$i * 0.2 + 0.5}s;
            }
        }
    }

    .section-team__items-wrapp {
        width: calc(25% - 20px);
        height: var(--cube-width);
        margin: 0 10px 20px;

        @include media-tablet {
            width: calc(33.33% - 20px);
            margin: 0 10px 20px;
        }
        
        @include media-mobile {
            width: calc(50% - 15px);
            margin: 0 5px 10px;
        }
    }

    .viewport {
        -webkit-perspective: 1000px;
        width: 100%;
        height: 100%;
        position: absolute;
    }

    .cube {
        transform: rotateX(0deg) rotateY(0deg) rotateZ(0deg);
        transform-style: preserve-3D;
        width: 100%;
        height: 100%;
        transition: transform 1s ease;
    }

    .cube div {
        width: 100%;
        height: 100%;
        position: absolute;
    }

    .cube-item {
        background: $main-color-bg;
        width: calc(100% - 1px);
        height: calc(100% - 1px);
    }

    .cube-item.front-cube {
        overflow: hidden;
        padding: 1px;

        .front-cube-content {
            background: rgba(255, 255, 255, 0.02);
            position: relative;
            padding: 25px;

            @include media-mobile {
                padding: 20px;
            }
        
            @include media-mobile-small-360 {
                padding: 10px;
            }
        
            &::after{
                content: '';
                background: url('./images/noise_team.png') center center /cover;
                position: absolute;
                top: 0;
                left: 0;
                right: 0;
                bottom: 0;
                opacity: 20%;
            }
        }

        .front-cube-inner {
        background: $main-color-bg;
        width: calc(100% - 2px);
        height: calc(100% - 2px);

            &::after, &::before {
                content: '';
                position: absolute;
            }

            &::after {
                z-index: -2;
                top: -1px;
                bottom: -1px;
                left: -1px;
                right: -1px;
                background-color: #666666;
            }
        
            &::before {
                z-index: -1;
                top: calc(-2px - 25%);
                bottom: calc(-2px - 25%);
                left: calc(-2px - 25%);
                right: calc(-2px - 25%);
                background: linear-gradient(141.8deg, #00FFFF 14.44%, #01C4E5 86.47%);
                transform: translate(-100%, -100%);
                border-radius: 50%;
                transition: transform 0.7s linear;
            }

            &:hover:before {
            transform: translate(0, 0);
            }
        }    
    }

  .bottom-cube {

        .photo-cube-img-wrapp {
            transform: rotateZ(180deg) rotateY(-180deg);
        }
    }
}

// section numbers
.section-numbers {

    .section-numbers__description {
        transform-origin: top left;
        @include main-animation;
    }

    &__text-wrapp {
        overflow: hidden;
    }

    .section-numbers__card {
        opacity: 0;

        .section-numbers__text {
            transform: translateY(120%);
        }

        .section-numbers__number {
            overflow: hidden;

            span {
                transform: translateY(120%);
                display: inline-block;
            }
        }
    }

    &.section-numbers-animation {

        .section-numbers__description {
            @include main-animation;
            animation: main_animation_title 2s $main-transition-timing forwards;
            animation-delay: 0.5s;
        }
    
        .title_basic {
            @include main-animation;
            animation: main_animation_title 1.5s ease forwards;
        }
    
        .section-numbers__card {
            @include card_basic_style;
            animation: card_basic 1.2s ease forwards;
            animation-delay: 0.5s;

            &.numbers-card-0 {
                @include media-tablet {
                    animation-delay: 0.5s;
                }
                .section-numbers__description {
                    @include media-tablet {
                        animation-delay: 0.8s;
                    }
                }
            }

            &.numbers-card-1 {
                @include media-tablet {
                    animation-delay: 1s;
                }

                .section-numbers__description {
                    @include media-tablet {
                        animation-delay: 1.3s;
                    }
                }
            }

            &.numbers-card-2 {
                @include media-tablet {
                    animation-delay: 2s;
                }
                .section-numbers__description {
                    @include media-tablet {
                        animation-delay: 2.3s;
                    }
                }
            }
    
            .section-numbers__text {
                animation: translate_to_top 1.5s ease forwards;
                animation-delay: 1.5s;
            }
    
            .section-numbers__number {
    
                span {
                    animation: translate_to_top 1s ease forwards;
                }
            }
        }
    }
}

// section contact
.section-contact {

    &__phrase {
        opacity: 0;
    }

    &__image {
        opacity: 0;
    }

    &.section-contact-animation {

        .title_basic {
            @include main-animation;
            animation: main_animation_title 2s $main-transition-timing forwards;
        }
    
        .section-contact__phrase {
            @include main-animation;
            animation: main_animation_title 1.5s $main-transition-timing forwards;
            animation-delay: 0.7s;
        }
    
        .section-contact__image {
            animation: opacity 2.5s ease forwards;
            position: relative;
            z-index: -1;
        }

        .section-contact__light-wrapp {
            width: 100%;
            height: 100%;
            position: absolute;
            top: 19%;
            display: inline-block;
            left: -24%;
            animation: circle 6s linear infinite;

            @include media-laptop {
                top: 17%;
                left: 14%;
                width: 500px;
                height: 370px;
            }

            @include media-tablet {
                top: -36%;
                left: -7%;
            }

            @include media-mobile {
                top: 0;
                left: 10%;
                width: 100%;
                height: 100%;
            }

            .section-contact__light {
                width: 510px;
                height: 400px;
                animation: inner-circle 6s linear infinite;

                @include media-mobile {
                    width: 300px;
                    height: 230px;
                }
            }
        }
    }
}

// footer 
footer {
    opacity: 0;

    &.footer-animation {
        animation: opacity 3s ease forwards;
    }
}

// keyframes
@keyframes banner_circle {
    from {
        transform: rotate(180deg) translateX(5px);
    }
    to   {
        transform: rotate(-540deg) translateX(5px);
    }
}

@keyframes banner_circle_small {
    from {
        transform: rotate(180deg) translateX(4px);
    }
    to   {
        transform: rotate(540deg) translateX(4px);
    }
}

@keyframes headline_items {
    0% {
        transform: translateY(20px) skew(0deg, 4deg);
        opacity: 0;
    }
    50% {
        opacity: 1;
    }
    100% {
        transform: translateY(0) skew(0, 0);
        opacity: 1;
    }
}

@keyframes card_basic {
    0% {
        transform: translateY(30%);
        opacity: 0;
    }
    100% {
        transform: translateY(0);
        opacity: 100%;
    }
}

@keyframes opacity {
    0% {
        opacity: 0;
    }
    100% {
        opacity: 1;
    }
}

@keyframes header {
    0% {
        transform: translateY(-30px);
    }
    100% {
        transform: translateY(0);
    }
}

@keyframes button_banner {
    0% {
        transform: translateY(30px);
    }
    100% {
        transform: translateY(0);
    }
}

@keyframes arrow_after {
    80% {
        right: -40px;
        top: calc(50% - 40px);
        opacity: 1;
    }
    85% {
        right: -40px;
        top: calc(50% - 40px);
        opacity: 0;
    }
    86% {
        right: 0;
        top: 50%;
        opacity: 0;
    }
    95% {
        opacity: 1;
    }
    100% {
        opacity: 1;
    }
}

@keyframes arrow_before {
    80% {
        right: 0;
        bottom: -5px;
        opacity: 1;
    }
    95% {
        opacity: 1;
    }
    99% {
        right: 0;
        bottom: -5px;
        opacity: 0;
    }
    100% {
        right: 32px;
        bottom: -40px;
        opacity: 1;
    }
}

@keyframes section_appearance {
    0% {
        transform: translateY(400px);
    }
    100% {
        transform: translateY(0);
    }
}

@keyframes  main_animation {
    0% {
        @include main-animation;
    }
    100% {
        opacity: 1;
        transform: translate3d(0px, 0em, 0px) scale3d(1, 1, 1) rotateX(0deg) rotateY(0deg) rotateZ(0deg) skew(0deg, 0deg);
        transform-style: preserve-3d;
    }
}

@keyframes  main_animation_title {
    0% {
        @include main-animation-small;
        
    }
    100% {
        opacity: 1;
        transform: translate3d(0px, 0em, 0px) scale3d(1, 1, 1) rotateX(0deg) rotateY(0deg) rotateZ(0deg) skew(0deg, 0deg);
        transform-style: preserve-3d;
    }
}

@keyframes translate_to_top {
    0% {
        transform: translateY(120%);
    }

    100% {
        transform: translateY(0);
    }
}

@keyframes circle {
    from { 
        transform:rotate(0deg); 
    }

    to { 
        transform:rotate(360deg); 
    }
}

@keyframes inner-circle {
    from { 
        transform:rotate(0deg); 
    }

    to { 
        transform:rotate(-360deg); 
    }
}

@keyframes translate-item-team {
    0% {
        transform: translateY(120%);
        opacity: 0;
    }

    100% {
        transform: translateY(0);
        opacity: 1;
    }
}

@keyframes preloader_animation {
    0% {
        transform: translateY(0);
    }
    100% {
        transform: translateY(-100%);
    }
}